<?php

	function __autoload($class_name) {
		require_once __rootPath . 'classes' . DS . $class_name . '.php';
	}

	function AddMessage($message, $type = MSG_SUCCESS) {

		switch ($type) {
			case MSG_ERROR:
				$_SESSION['SiteMessage']['Error'][] = $message;
				break;
			case MSG_SUCCESS:
				$_SESSION['SiteMessage']['Success'][] = $message;
				break;
			case MSG_INFO:
				$_SESSION['SiteMessage']['Info'][] = $message;
				break;
		}
	}

	function ParseTemplate($template) {
		GetSiteMessages();
		require_once(__templatePath.$template.'.php');
	}

	function GetSiteMessages() {

		$GLOBALS['DisplayErrorMessage'] = 'none';
		$GLOBALS['DisplayInfoMessage'] = 'none';
		$GLOBALS['DisplaySuccessMessage'] = 'none';

		$GLOBALS['ErrorMessage'] = '';
		$GLOBALS['InfoMessage'] = '';
		$GLOBALS['SuccessMessage'] = '';

		if (!isset($_SESSION['SiteMessage'])) {
			return;
		}

		if (isset($_SESSION['SiteMessage']['Error'])) {
			$GLOBALS['ErrorMessage'] = implode("\n", $_SESSION['SiteMessage']['Error']);
			$GLOBALS['DisplayErrorMessage'] = '';
		}

		if (isset($_SESSION['SiteMessage']['Info'])) {
			$GLOBALS['InfoMessage'] = implode("\n", $_SESSION['SiteMessage']['Info']);
			$GLOBALS['DisplayInfoMessage'] = '';
		}

		if (isset($_SESSION['SiteMessage']['Success'])) {
			$GLOBALS['SuccessMessage'] = implode("\n", $_SESSION['SiteMessage']['Success']);
			$GLOBALS['DisplaySuccessMessage'] = '';
		}

		unset($_SESSION['SiteMessage']);
	}

	function ArrayToDropdown($array, $selection = 0)
	{
		if (!is_array($array)) $array = array($array);

		$return = '';

		foreach($array AS $key => $value) {
			if ($selection == $key) {
				$selected = ' selected="selected"';
			}
			else {
				$selected = '';
			}
			$return .= "<option value='".$key."'".$selected.">".$value."</option>";
		}

		return $return;
	}

	function GetCarrierListArray()
	{
		$param = array('YES');
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT carrier_id,carrier_name FROM carriers WHERE active = ?", $param);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['carrier_id']] = $row['carrier_name'];
		}

		return $data;
	}

	function GetCurrencyListArray()
	{
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT currency_id,currency_name FROM currencies");
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['currency_id']] = $row['currency_name'];
		}

		return $data;
	}

	function GetIVRListArray()
	{
		$params = array('YES');
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT ivr_id,ivr_name FROM ivr WHERE active = ?", $params);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['ivr_id']] = $row['ivr_name'];
		}

		return $data;
	}

	function GetUserListArray($usertype)
	{
		//$params = array('YES', $usertype, 2);
		//$query = "SELECT id,user_name FROM users WHERE active = ? AND user_type = ? AND id != ?";
		//if (ShouldHaveAccess('RESELLER', false)) {
		//	$params[] = $_SESSION['User']['userid'];
		//	$query .= " AND parent_user_id = ?";
		//}
		$params = array('YES', $_SESSION['User']['userid']);
		$query = "SELECT id,user_name FROM users WHERE active = ? AND parent_user_id = ?";

		$result = $GLOBALS['CLASS_DB']->rawQuery($query, $params);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['id']] = $row['user_name'];
		}

		return $data;
	}

	function GetRangeListArray()
	{
		$param = array('YES');
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT range_id,range_name FROM number_ranges WHERE active = ?", $param);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['range_id']] = $row['range_name'];
		}

		return $data;
	}

	function GetAssosiatedRangeListArray()
	{
		$param = array('YES');
		$query="SELECT range_id,range_name FROM number_ranges
				WHERE active = ?";
		if($_SESSION['User']['type'] == 'ADMIN')
		{
			//$query.=" AND admin_id= ?";
			//$param[] = $_SESSION['User']['userid'];
		}elseif ($_SESSION['User']['type'] == 'RESELLER') {
			$query.=" AND range_id IN(SELECT DISTINCT range_id FROM number_range_detail WHERE reseller_id=?)";
			$param[] = $_SESSION['User']['userid'];
		}else{
			$query.=" AND range_id IN(SELECT DISTINCT range_id FROM number_range_detail WHERE enduser_id=?)";
			$param[] = $_SESSION['User']['userid'];
		}
		$query.=" ORDER BY range_name";
		$result = $GLOBALS['CLASS_DB']->rawQuery($query, $param);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['range_id']] = $row['range_name'];
		}

		return $data;
	}


	function GetPayoutListArray()
	{
		$param = array('YES');
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT range_id,range_name FROM number_ranges WHERE active = ?", $param);
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			$data[$row['range_id']] = $row['range_name'];
		}

		return $data;
	}

	function ShouldHaveAccess($userTypes, $redirect = true)
	{
		if (!is_array($userTypes)) $userTypes = array($userTypes);

		if (isset($_SESSION['User']['type']) && in_array($_SESSION['User']['type'], $userTypes)) {
			return true;
		}
		else {
			if ($redirect) {
				AddMessage("You dont have access to this feature", MSG_ERROR);
				header("Location: index.php?ToDo=accessForbidded");
				exit;
			}
			else {
				return false;
			}
		}
	}

	function GetCDRSRateListArray($field = 'admin_rate')
	{
		$result = $GLOBALS['CLASS_DB']->rawQuery("SELECT DISTINCT(".$field.") AS Rate FROM cdrs");
		$data[0] = '-- Any --';
		foreach($result AS $row) {
			if(is_numeric($row['Rate'])){
				$row['Rate']=round($row['Rate'],4);
			}
			$data[$row['Rate']] = $row['Rate'];
		}

		return $data;
	}

?>
